#pragma once

#include <Event.h>
#include <ReWindow/types/WindowEvents.h>

namespace InputService {
    using namespace ReWindow;

    inline Event<KeyboardEvent> OnKeyboardEvent;
    inline Event<KeyboardEvent> OnKeyEvent;
    inline Event<KeyDownEvent> OnKeyDown;
    inline Event<KeyUpEvent> OnKeyUp;
    inline Event<MouseMoveEvent> OnMouseEvent;
    inline Event<MouseButtonEvent> OnMouseButtonEvent;
    inline Event<MouseMoveEvent> OnMouseMove;
    inline Event<MouseButtonDownEvent> OnMouseDown;
    inline Event<MouseButtonUpEvent> OnMouseUp;
    inline Event<MouseWheelEvent> OnMouseWheel;
    bool IsKeyDown(const Key& key);
    bool IsMouseButtonDown(const MouseButton& button);
    IPair GetMousePosition();
    IPair GetWindowSize();
};