#pragma once

namespace ReWindow {
    class IPair;
    class FPair;
}

class ReWindow::IPair {
public:
    int x, y;
public:
    IPair operator +(const IPair& rhs) const;
    IPair operator -(const IPair& rhs) const;
    IPair operator *(const IPair& rhs) const;
    IPair operator /(const IPair& rhs) const;
public:
    IPair& operator +=(const IPair& rhs);
    IPair& operator -=(const IPair& rhs);
    IPair& operator *=(const IPair& rhs);
    IPair& operator /=(const IPair& rhs);
public:
    bool operator ==(const IPair& rhs) const;
    bool operator !=(const IPair& rhs) const;
public:
    IPair(const IPair& rhs);
    IPair() : x(0), y(0) {};
    IPair(int x, int y) : x(x), y(y) {};
    ~IPair() = default;
};

class ReWindow::FPair {
public:
    float x, y;
public:
    FPair operator +(const FPair& rhs) const;
    FPair operator -(const FPair& rhs) const;
    FPair operator *(const FPair& rhs) const;
    FPair operator /(const FPair& rhs) const;
public:
    FPair& operator +=(const FPair& rhs);
    FPair& operator -=(const FPair& rhs);
    FPair& operator *=(const FPair& rhs);
    FPair& operator /=(const FPair& rhs);
public:
    bool operator ==(const FPair& rhs) const;
    bool operator !=(const FPair& rhs) const;
public:
    FPair(const FPair& rhs);
    explicit FPair(const IPair& rhs);
    FPair() : x(0), y(0) {};
    FPair(float x, float y) : x(x), y(y) {};
    ~FPair() = default;
};